<?php
//IMathAS - User Details page
//(c) 2017 David Lippman

require_once "../init.php";

$overwriteBody = 0;
$body = "";

$isadmin = ($myrights == 100);

if ($myrights < 20) {
 	$overwriteBody = 1;
	$body = "You don't have authority to view this page.";
} else if (isset($_POST['removeuserlti'])) {
  $id = intval($_POST['removeuserlti']);
  if ($isadmin) {
    $stm = $DBH->prepare("DELETE FROM imas_ltiusers WHERE id=:id");
    $stm->execute(array(':id'=>$id));
  } else {
    $stm = $DBH->prepare("DELETE FROM imas_ltiusers WHERE id=:id AND userid=:userid");
    $stm->execute(array(':id'=>$id, 'userid'=>$userid));
  }
  if ($stm->rowCount()>0) {
    echo "OK";
  } else {
    echo "ERROR";
  }
  exit;
} else if (isset($_POST['removecourselti'])) {
  $id = Sanitize::onlyInt($_POST['removecourselti']);
  if ($isadmin) {
    $stm = $DBH->prepare("SELECT org,contextid,courseid FROM imas_lti_courses WHERE id=:id");
    $stm->execute(array(':id'=>$id));
  } else {
    $stm = $DBH->prepare("SELECT ilc.org,ilc.contextid,ilc.courseid FROM imas_lti_courses AS ilc
        JOIN imas_teachers AS it ON ilc.courseid=it.courseid AND it.userid=:userid
        WHERE ilc.id=:id");
    $stm->execute(array(':userid'=>$userid, ':id'=>$id));
  }
  $row = $stm->fetch(PDO::FETCH_ASSOC);
  if ($row===false) {
  	  echo "ERROR";
  	  exit;
  }
  $stm = $DBH->prepare("DELETE FROM imas_lti_placements WHERE org=:org AND contextid=:contextid");
  $stm->execute(array(':org'=>$row['org'], ':contextid'=>$row['contextid']));

  $stm = $DBH->prepare("DELETE FROM imas_lti_courses WHERE id=:id");
  $stm->execute(array(':id'=>$id));

  require_once '../includes/TeacherAuditLog.php';
  TeacherAuditLog::addTracking(
    $row['courseid'],
    "Course Settings Change",
    $row['courseid'],
    [
      'action'=>'LTI connection broken',
      'contextid'=>$row['contextid'],
      'by'=>$userid
    ]
  );

  echo "OK";
  exit;
} else if (isset($_POST['removeplacementlti'])) {
  $id = intval($_POST['removeplacementlti']);
  if (!$isadmin) {
    $stm = $DBH->prepare("SELECT typeid,placementtype FROM imas_lti_placements WHERE id=:id");
    $stm->execute(array(':id'=>$id));
    $row = $stm->fetch(PDO::FETCH_ASSOC);
    if ($row['placementtype']=='assess') {
        $query = "SELECT it.id FROM imas_assessments AS ia
            JOIN imas_teachers AS it ON ia.courseid=it.courseid AND it.userid=:userid
            WHERE ia.id=:id";
    } else if ($row['placementtype']=='course') {
        $query = "SELECT it.id FROM imas_courses AS ic 
            JOIN imas_teachers AS it ON ic.id=it.courseid AND it.userid=:userid
            WHERE ic.id=:id";
    } else {
        echo "ERROR"; exit;
    }
    $stm = $DBH->prepare($query);
    $stm->execute(array(':userid'=>$userid, ':id'=>$row['typeid']));
    if ($stm->rowCount()==0) {
        echo "ERROR"; exit;
    }
  }
  $stm = $DBH->prepare("DELETE FROM imas_lti_placements WHERE id=:id");
  $stm->execute(array(':id'=>$id));
  if ($stm->rowCount()>0) {
    echo "OK";
  } else {
    echo "ERROR";
  }
  exit;
} else if (!empty($_GET['contextid'])) {
  $contextid = Sanitize::simpleString($_GET['contextid']);
  $org = Sanitize::simpleASCII($_GET['org']);
  if (substr($org,0,5)=='LTI13') {
      $searchstr = 'ilp.org=? ';
      $sorg = $org;
  } else {
      $searchstr = 'ilp.org LIKE ? ';
      $sorg = $org . ':%';
  }
  $query = "SELECT ilp.id,ilp.linkid,ilp.typeid,ilp.placementtype,ia.name FROM ";
  $query .= "imas_lti_placements AS ilp LEFT JOIN imas_assessments AS ia ON ilp.typeid=ia.id ";
  $query .= "WHERE ilp.contextid=? AND ilp.placementtype='assess' AND $searchstr UNION ";
  $query .= "SELECT ilp.id,ilp.linkid,ilp.typeid,ilp.placementtype,ic.name FROM ";
  $query .= "imas_lti_placements AS ilp LEFT JOIN imas_courses AS ic ON ilp.typeid=ic.id ";
  $query .= "WHERE ilp.contextid=? AND ilp.placementtype='course' AND $searchstr";
  $stm = $DBH->prepare($query);
  $stm->execute(array($contextid, $sorg, $contextid, $sorg));
  echo json_encode($stm->fetchAll(PDO::FETCH_ASSOC), JSON_HEX_TAG);
  exit;

} else {
  if ($isadmin) {
    $uid = Sanitize::onlyInt($_GET['id'] ?? $userid);
  } else {
    $uid = $userid;
  }
  $query = "SELECT iu.FirstName,iu.LastName,ig.name AS gname,ig.parent ";
  $query .= "FROM imas_users AS iu LEFT JOIN imas_groups AS ig ON iu.groupid=ig.id WHERE iu.id=:id";
  $stm = $DBH->prepare($query);
  $stm->execute(array(':id'=>$uid));
  $userinfo = $stm->fetch(PDO::FETCH_ASSOC);

  $stm = $DBH->prepare("SELECT org,id,ltiuserid FROM imas_ltiusers WHERE userid=:userid");
  $stm->execute(array(':userid'=>$uid));
  $user_lti = $stm->fetchAll(PDO::FETCH_ASSOC);
  if ($user_lti===false) {
    $user_lti = array();
  }

  $query = "SELECT ilc.org,ilc.id,ilc.courseid,ilc.contextid,ilc.contextlabel,ic.name FROM imas_lti_courses AS ilc ";
  $query .= "JOIN imas_teachers AS it ON ilc.courseid=it.courseid ";
  $query .= "JOIN imas_courses AS ic ON it.courseid=ic.id WHERE it.userid=:userid ";
  $query .= "ORDER BY ic.name";
  $stm = $DBH->prepare($query);
  $stm->execute(array(':userid'=>$uid));
  $course_lti = $stm->fetchAll(PDO::FETCH_ASSOC);
  if ($course_lti===false) {
    $course_lti = array();
  }
}

$curBreadcrumb = $breadcrumbbase;
if ($isadmin) {
    $curBreadcrumb .=' <a href="admin2.php">'._('Admin').'</a> &gt; ';
    $curBreadcrumb .= '<a href="userdetails.php?id='.$uid.'">'._('User Details').'</a> &gt; ';
}
$curBreadcrumb .= _('LTI Connections');

/******* begin html output ********/
$placeinhead = "<script type=\"text/javascript\" src=\"$staticroot/javascript/tablesorter.js\"></script>\n";
$placeinhead .= '<script type="text/javascript">
function removeuserlti(el,id) {
  return removelti(el,"user",id);
}
function removecourselti(el,id) {
  return removelti(el,"course",id);
}
function removeplacement(el,id) {
  return removelti(el,"placement",id);
}
function removelti(el,type,id) {
  if (confirm("'._('Are you SURE?').'")) {
    $.ajax({
      url: "userlti.php",
      type: "POST",
      data: "remove"+type+"lti="+id
    }).done(function(msg) {
      if (msg=="OK") {
        $(el).closest("tr").fadeOut(500,function() {
          //restripe
          var parenttable = $(el).closest("table");
          $(el).closest("tr").remove();
          $(parenttable).find("tbody tr:even").addClass("even").removeClass("odd");
          $(parenttable).find("tbody tr:odd").addClass("odd").removeClass("even");
        });
      } else {
        alert("Error removing LTI connection");
      }
    });
  }
  return false;
}
$(function() {
  $(".contextid").on("click", function(event) {
    var contextid = $(event.target).html().split("<br")[0];
    var org = $(event.target).prev().html().split(":")[0];
    $.ajax({
      url: "userlti.php",
      data: "contextid="+contextid+"&org="+org,
      dataType: "json"
    }).done(function(msg) {
      $("#placements tbody").empty();
      $.each(msg, function (i, item) {
        var tr = $("<tr>").append(
          $("<td>").text(item.placementtype),
          $("<td>").text(item.name),
          $("<td>").text(item.typeid),
          $("<td>").text(item.linkid),
          $("<td>").append(
            $("<a>").text("Remove connection")
             .attr("href","#")
             .attr("onclick","return removeplacement(this,"+item.id+")")
          )
        )
        $("#placements tbody").append(tr);
      });
      $("#placementwrap h4").text(_("LTI placements in contextid: ")+contextid);
      $("#placements").find("tbody tr:even").addClass("even");
      $("#placements").find("tbody tr:odd").addClass("odd");
      $("#placementwrap").show();
    });
  });
})
</script>';
require_once "../header.php";

if ($overwriteBody==1) {
  echo $body;
} else {
  echo '<div class=breadcrumb>',$curBreadcrumb, '</div>';
	echo '<div id="headeruserdetail" class="pagetitle"><h1>'._('LTI Connections').': ';
  echo '<span class="pii-full-name">';
  echo Sanitize::encodeStringForDisplay($userinfo['LastName'].', '.$userinfo['FirstName']);
  echo '</span></h1></div>';

  echo '<p>'._('Group').': '.Sanitize::encodeStringForDisplay($userinfo['gname']).'</p>';

  echo '<p><strong><a href="#" class="togglecontrol" aria-controls="instructions">'._('Instructions').'</a></strong></p>';
  echo '<div id="instructions" style="display:none;">';
?>
<p>At the top of the page you will see a section for <strong>LTI user connections</strong>.
This is how <?php echo $installname;?> links your LMS account to your <?php echo $installname;?> account.
Each connection is tied to the LTI key being used, so you may see multiple rows.
Generally there should be no reason to need this section. The only time you'd need to remove a user connection is if you accidentally logged into someone else's <?php echo $installname;?> account, or you logged into your own <?php echo $installname;?> account from someone else's LMS account. 
If you remove a user connection, it will require you to login again to your <?php echo $installname;?> account when you click a link from the LMS.</p>
<p>The second section for <strong>LTI course connections</strong> is the one you're more likely to need.&nbsp;</p>
<ul>
<li>The first two columns list your <?php echo $installname;?> course name and ID.&nbsp;</li>
<li>The third column shows the LTI key the connection is using&nbsp;</li>
<li>The fourth column labeled "contextid/label" shows a unique course identifier sent by the LMS (which will look like a random string), and below it will be the LMS course name, if the LMS sent it.</li>
</ul>
<p>If you linked your LMS course to the wrong <?php echo $installname;?> course, here's where you'd handle that.&nbsp;</p>
<ul>
<li>First, you'll want to verify what <?php echo $installname;?> course you're currently linked with.&nbsp; To do that:
<ul>
<li>Click a <?php echo $installname;?> link from the LMS course.</li>
<li>If you see "LTI Home" at the top, click that.&nbsp;&nbsp;</li>
<li>If you see LTI with a triangle at the top, click that and select "Info and LMS Sync".</li>
<li>Scroll down and look for "This assessment is housed in course ID ____"</li>
</ul>
</li>
<li>In the LTI course connection list, look for that course ID.&nbsp; I can help to sort the table by the Course ID column.&nbsp; The course may be linked to multiple LMS courses, so look at the "contextid/label" column to find the right LMS course, if possible.&nbsp;</li>
<li>To break the connection, click Remove Connection</li>
</ul>
<p><span style="color: #ff0000;">WARNINGS: </span></p>
<ul>
<li>Once you break the course connection, students won't be able to use any <?php echo $installname;?> links until you establish a new connection.</li>
<li>When you click on a <?php echo $installname;?> link from the LMS, <?php echo $installname;?> will prompt again for what course you want to associate with or copy.&nbsp; If you connect to a different course, be aware that <em>students will lose access to any work done under the original course connection</em> (though any score already in Canvas will still be in Canvas), and any future work will be in the newly associated course.</li>
</ul>
<p>A common situation that's come up with course-level LTI keys is that someone will setup their course, it will be working fine, then they'll either change the LTI key, or accidentally import a second <?php echo $installname;?> "app" and put a different LTI key on it.&nbsp; Since course connections are linked to the key used, this creates a new course connection and new user connections, meaning students are now either working in a new course, or they have a new user account tied to that new key and you end up with duplicate enrollments in your <?php echo $installname;?> course.&nbsp; If this happens, you have a choice:</p>
<ul>
<li>Leave it alone, and all new student work will be in the new course or under the new enrollment</li>
<li>Switch back to the old LTI key, and students will have access again to the old course or enrollment, but will lose access to anything done during the mixup</li>
</ul>
<p>Either way, breaking a course connection doesn't really help here.&nbsp; Also no, there's not a way to merge the work or enrollments; you'll just have to live with it.&nbsp;</p>
<p>There is an additional feature on this page.&nbsp; Once you find your course connection listing, if you click on the "contextid/label" value for that row, a new table will show up at the bottom of the page, listing all the individual assessment connections.&nbsp; It lists the type of link, the assessment name, and a unique linkid from the LMS, and you can break the individual connection.&nbsp; This would only ever be needed if you were using the content selector tool in your LMS, and selected the wrong assignment, and wanted to change it.&nbsp; The easier way is to just delete the assignment in the LMS and create a new one, but breaking the connection here would be another way.</p>
<p><em>Use at your own risk.&nbsp; Breaking a connection is not un-doable.</em></p>
<?php
  echo '</div>';

  echo '<h3>'._('LTI user connections').'</h3>';
  echo '<table class="gb" id="ltiusers"><thead><tr>';
  echo '<th>'._('Key:org').'</th>';
  echo '<th>'._('Remote Userid').'</th>';
  echo '<th>'._('Remove').'</th>';
  echo '</tr></thead><tbody>';
  $alt = 0;
  foreach ($user_lti as $u) {
    if ($alt==0) {echo "<tr class=even>"; $alt=1;} else {echo "<tr class=odd>"; $alt=0;}
    echo '<td>',Sanitize::encodeStringForDisplay($u['org']),'</td>';
    echo '<td>',Sanitize::encodeStringForDisplay($u['ltiuserid']),'</td>';
    echo '<td><a onclick="return removeuserlti(this,'.Sanitize::encodeStringForJavascript($u['id']).')" href="#">';
    echo _('Remove connection').'</a></td>';
    echo '</tr>';
  }
  echo '</tbody></table>';
  echo '<script type="text/javascript">
    initSortTable("ltiusers",Array("S","S",false),true);
    </script>';

  echo '<h3>'._('LTI course connections').'</h3>';
  echo '<p class=noticetext>'._('WARNING!!! Breaking a course connection will prevent students from accessing assignments until you reestablish a new connection. ');
  echo _('If you establish a new connection to a different course, then students will lose access to any work done in the current course. ');
  echo '</p>';

  echo '<table class="gb" id="lticourses"><thead><tr>';
  echo '<th>'._('Course').'</th>';
  echo '<th>'._('Course ID').'</th>';
  echo '<th>'._('Key:org').'</th>';
  echo '<th>'._('contextid / label').'</th>';
  echo '<th>'._('Remove').'</th>';
  echo '</tr></thead><tbody>';
  $alt = 0;
  foreach ($course_lti as $u) {
    if ($alt==0) {echo "<tr class=even>"; $alt=1;} else {echo "<tr class=odd>"; $alt=0;}
    echo '<td>',Sanitize::encodeStringForDisplay($u['name']),'</td>';
    echo '<td>',Sanitize::encodeStringForDisplay($u['courseid']),'</td>';
    echo '<td>',Sanitize::encodeStringForDisplay($u['org']),'</td>';
    echo '<td class="contextid pointer">',Sanitize::encodeStringForDisplay($u['contextid']);
    if ($u['contextlabel'] != '') {
    	    echo '<br/>',Sanitize::encodeStringForDisplay($u['contextlabel']);
    }
    echo '</td>';
    echo '<td><a onclick="return removecourselti(this,'.Sanitize::encodeStringForJavascript($u['id']).')" href="#">';
    echo _('Remove connection').'</a></td>';
    echo '</tr>';
  }
  echo '</tbody></table>';
  echo '<script type="text/javascript">
    initSortTable("lticourses",Array("S","N","S","S",false),true);
    </script>';
  echo '<p>'._('Click a contextid above to list the associated placements').'</p>';
  echo '<div id="placementwrap" style="display:none"><h3></h3>';
  echo '<table id="placements" class="gb"><caption></caption><thead><tr>';
  echo '<th>',_('Type'),'</th>';
  echo '<th>',_('Item'),'</th>';
  echo '<th>',_('Item ID'),'</th>';
  echo '<th>',_('Linkid'),'</th>';
  echo '<th>',_('Remove'),'</th>';
  echo '</tr></thead><tbody></tbody></table></div>';
}
require_once "../footer.php";
